/*
  -: Copyright  1999-2004 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
*/


#include <stdio.h>
#include <iostream>
#include <iomanip>

#define lNoHT 0
#define lHead 1
#define lTail 2
#define lHT 3

using namespace std;

template <class T> struct Element_T {
	T Data;
	Element_T *Previous;
	Element_T *Next;
};
template <class T> class List {
	Element_T<T> *CurrentElement;
public:
	List();
	~List();
	int MakeEmpty() {
		Element_T<T> *temp;
		if (CurrentElement==NULL) return 0;
		while (!( ((CurrentElement->Next==NULL)&&(CurrentElement->Previous==NULL))||(CurrentElement->Next==CurrentElement) )) {
			if (((CurrentElement->Next!=NULL)&&(CurrentElement->Previous!=NULL))) {
				temp=CurrentElement;
				CurrentElement->Next->Previous=CurrentElement->Previous;
				CurrentElement->Previous->Next=CurrentElement->Next;
				CurrentElement=CurrentElement->Next;
				delete temp;
			} else if (CurrentElement->Next==NULL) {
				temp=CurrentElement;
				CurrentElement->Previous->Next=CurrentElement->Next;
				CurrentElement=CurrentElement->Previous;
				delete temp;
			} else if (CurrentElement->Previous==NULL) {
				temp=CurrentElement;
				CurrentElement->Next->Previous=CurrentElement->Previous;
				CurrentElement=CurrentElement->Next;
				delete temp;
			}
		}
		delete CurrentElement;
		CurrentElement=NULL;
		return 0;
	}
	bool Empty() {
		if (!(CurrentElement==NULL)){
			return false;
		} else {
			return true;
		}
	}
	int HTProp() {
		if (CurrentElement==NULL) return -1 ;
		if ((CurrentElement->Next==NULL)&&(CurrentElement->Previous==NULL)) {
			return lHT;
		} else if (CurrentElement->Next==NULL) {
			return lTail;
		} else if (CurrentElement->Previous==NULL) {
			return lHead;
		} else {
			return lNoHT;
		}
	}
	int DeleteCurrent() {
		Element_T<T> *temp;
		if (CurrentElement==NULL) return -1 ;
		if ((HTProp()==lHT)||(CurrentElement->Next==CurrentElement)) {
			delete CurrentElement;
			CurrentElement=NULL;
		} else if ((CurrentElement->Next!=NULL)&&(CurrentElement->Previous!=NULL)) {
			temp=CurrentElement;
			CurrentElement->Next->Previous=CurrentElement->Previous;
			CurrentElement->Previous->Next=CurrentElement->Next;
			CurrentElement=CurrentElement->Next;
			delete temp;
		} else if (CurrentElement->Next==NULL) {
			temp=CurrentElement;
			CurrentElement->Previous->Next=CurrentElement->Next;
			CurrentElement=CurrentElement->Previous;
			delete temp;
		} else if (CurrentElement->Previous==NULL) {
			temp=CurrentElement;
			CurrentElement->Next->Previous=CurrentElement->Previous;
			CurrentElement=CurrentElement->Next;
			delete temp;
		}
		return 0;
	}
	int AddAfter(T data) {
		if (CurrentElement==NULL) return -1 ;
		Element_T<T> *temp;
		temp=new Element_T<T>;
		temp->Data=data;
		temp->Previous=CurrentElement;
		temp->Next=CurrentElement->Next;
		if (CurrentElement->Next!=NULL) CurrentElement->Next->Previous=temp;
		CurrentElement->Next=temp;
		return 0;
	}
	int AddBefore(T data) {
		if (CurrentElement==NULL) return -1 ;
		Element_T<T> *temp;
		temp=new Element_T<T>;
		temp->Data=data;
		temp->Next=CurrentElement;
		temp->Previous=CurrentElement->Previous;
		if (CurrentElement->Previous!=NULL) CurrentElement->Previous->Next=temp;
		CurrentElement->Previous=temp;
		return 0;
	}
	int GetCurrent(T &data) {
		if (CurrentElement==NULL) return -1 ;
		data=CurrentElement->Data;
		return 0;
	}
	int PutInCurrent(T data) {
		if (CurrentElement==NULL) return -1 ;
		CurrentElement->Data=data;
		return 0;
	}
	int SetToHead() {
		if (CurrentElement==NULL) return -1 ;
		Element_T<T> *temp;
		temp=CurrentElement;
		while ((temp->Previous!=CurrentElement)&&(temp->Previous!=NULL)) temp=temp->Previous;
		if (temp->Previous==NULL) CurrentElement=temp; 
			else return -1;
		return 0;
	}
	int SetToTail() {
		if (CurrentElement==NULL) return -1 ;
		Element_T<T> *temp;
		temp=CurrentElement;
		while ((temp->Next!=CurrentElement)&&(temp->Next!=NULL)) temp=temp->Next;
		if (temp->Next==NULL) CurrentElement=temp;
			else return -1;
		return 0;
	}
	bool Circular() {
		if (CurrentElement==NULL) return false ;
		Element_T<T> *temp;
		temp=CurrentElement;
		while ((temp->Next!=CurrentElement)&&(temp->Next!=NULL)) temp=temp->Next;
		if (temp->Next==NULL) return false; 
			else return true;
	}
	int MakeCircular() {
		if (CurrentElement==NULL) return -1 ;
		Element_T<T> *Head;
		Element_T<T> *Tail;
		Tail=CurrentElement;
		while ((Tail->Next!=CurrentElement)&&(Tail->Next!=NULL)) Tail=Tail->Next;
		if (Tail->Next==CurrentElement) return 0;
		Head=Tail;
		Tail->Next=Head;
		while (Head->Previous!=NULL) Head=Head->Previous;
		Tail->Next=Head;
		Head->Previous=Tail;
		return 0;
	}
	int TearAfter() {
		if (CurrentElement==NULL) return -1 ;
		if (Circular()) {
			CurrentElement->Next->Previous=NULL;
			CurrentElement->Next=NULL;
		} else return -1;
		return 0;
	}
	int TearBefore() {
		if (CurrentElement==NULL) return -1 ;
		if (Circular()) {
			CurrentElement->Previous->Next=NULL;
			CurrentElement->Previous=NULL;
		} else return -1;
		return 0;
	}
	int Length() {
		if (CurrentElement==NULL) return 0;
		int n=1;
		Element_T<T> *temp;
		temp=CurrentElement;
		while ((temp->Next!=CurrentElement)&&(temp->Next!=NULL)) {
			temp=temp->Next;
			n++;
		}
		if (temp->Next==NULL) {
			n=1;
			while (temp->Previous!=NULL) {
				temp=temp->Previous;
				n++;
			}
		}
		return n;
	}
	int Get(T &data, int n) {
		if (CurrentElement==NULL) return 0;
		Element_T<T> *temp;
		int i=1;
		temp=CurrentElement;
		while ((temp->Previous!=CurrentElement)&&(temp->Previous!=NULL)) temp=temp->Previous;
		if (temp->Previous==NULL) {
			while (i<n) {
				if (temp->Next==NULL) return -1;
				temp=temp->Next;
				i++;
			};
			data=temp->Data;
		} else return -1;
		return 0;
	}
	int SetToNext() {
		if (CurrentElement==NULL) return -1;
		if (CurrentElement->Next==NULL) return -1;
		CurrentElement=CurrentElement->Next;
		return 0;
	}
	int SetToPrevious() {
		if (CurrentElement==NULL) return -1;
		if (CurrentElement->Previous==NULL) return -1;
		CurrentElement=CurrentElement->Previous;
		return 0;
	}
	int MoveForward() {
		if (CurrentElement==NULL) return -1;
		if (CurrentElement->Next==NULL) return -1;
		if ((CurrentElement->Next==CurrentElement)||(CurrentElement->Next->Next==CurrentElement)) return 0;
		if (CurrentElement->Previous!=NULL) {
			CurrentElement->Previous->Next=CurrentElement->Next;
			CurrentElement->Next->Previous=CurrentElement->Previous;
		} else CurrentElement->Next->Previous=NULL;
		Element_T<T> *temp;
		temp=CurrentElement->Next;
		if (temp->Next!=NULL) {
			temp->Next->Previous=CurrentElement;
			CurrentElement->Next=temp->Next;
		} else CurrentElement->Next=NULL;
		CurrentElement->Previous=temp;
		temp->Next=CurrentElement;
		return 0;
	}
	int MoveBackward() {
		if (CurrentElement==NULL) return -1;
		if (CurrentElement->Previous==NULL) return -1;
		if ((CurrentElement->Previous==CurrentElement)||(CurrentElement->Previous->Previous==CurrentElement)) return 0;
		if (CurrentElement->Next!=NULL) {
			CurrentElement->Next->Previous=CurrentElement->Previous;
			CurrentElement->Previous->Next=CurrentElement->Next;
		} else CurrentElement->Previous->Next=NULL;
		Element_T<T> *temp;
		temp=CurrentElement->Previous;
		if (temp->Previous!=NULL) {
			temp->Previous->Next=CurrentElement;
			CurrentElement->Previous=temp->Previous;
		} else CurrentElement->Previous=NULL;
		CurrentElement->Next=temp;
		temp->Previous=CurrentElement;
		return 0;
	}
	int Add(T data) {
		if (CurrentElement==NULL) {
			Element_T<T> *NewElement;
			NewElement=new Element_T<T>;
			NewElement->Data=data;
			NewElement->Next=NULL;
			NewElement->Previous=NULL;
			CurrentElement=NewElement;
			return 0;
		}
		Element_T<T> *temp;
		temp=CurrentElement;
		while ((temp->Next!=CurrentElement)&&(temp->Next!=NULL)) temp=temp->Next;
		if (temp->Next==NULL) {
			Element_T<T> *NewElement;
			NewElement=new Element_T<T>;
			NewElement->Data=data;
			NewElement->Next=NULL;
			NewElement->Previous=temp;
			temp->Next=NewElement;
		} else return -1;
		return 0;
	}
};
template <class T>
List<T>::List()
{
	CurrentElement=NULL;
}
template <class T>
List<T>::~List()
{
	int i;
	i=MakeEmpty();
}

template <class T> int PrintListState (List<T> L);

int main(int argc, char* argv[])
{
	List<double> MyList;
	int i=0, n;
	double dt;
	char c[3];
	cout << setprecision(12);
	do {
		i=PrintListState(MyList);
		cout << "'me' - Make Empty;\n";
		cout << "'e'  - Empty?\n";
		cout << "'a'  - Add an Element at the tail of the List;\n";
		cout << "'aa' - Add an Element after the Current Element of the List;\n";
		cout << "'ab' - Add an Element before the Current Element of the List;\n";
		cout << "'mc' - Make Circular;\n";
		cout << "'c'  - Circular?\n";
		cout << "'d'  - Delete the Current Element;\n";
		cout << "'g'  - Get data from the n-th element of the List;\n";
		cout << "'gc' - Get data from the Current Element;\n";
		cout << "'ht' - Is the Current Element a Head or a Tail element?\n";
		cout << "'l'  - Length of the List;\n";
		cout << "'mf' - Move forward the Current Element;\n";
		cout << "'mb' - Move backward the Current Element;\n";
		cout << "'p'  - Put data in the Current Element;\n";
		cout << "'sh' - Set the Current Element to the head of the List;\n"; 
		cout << "'st' - Set the Current Element to the tail of the List;\n";
		cout << "'sn' - Set the Current Element to the next element;\n";
		cout << "'sp' - Set the Current Element to the previous element;\n";
		cout << "'ta' - Tear the circular List after the Current Element;\n";
		cout << "'tb' - Tear the circular List before the Current Element;\n";
		cout << "'q'  - Quit;\n";
		cin >> c;
		switch(c[0]) {
			case 'm': {
				if (c[1]=='e') {
					i=MyList.MakeEmpty();
				} else if (c[1]=='c') {
					i=MyList.MakeCircular();
					if (i<0) cout << "Error: the List is empty!\n";
					i=0;
				} else if (c[1]=='f') {
					i=MyList.MoveForward();
					if (i<0) cout << "Error: the Next element of the Current Element doesn't exist!\n";
					i=0;
				} else if (c[1]=='b') {
					i=MyList.MoveBackward();
					if (i<0) cout << "Error: the Previous element of the Current Element doesn't exist!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'e': {
				if (c[1]=='\0') {
					if (MyList.Empty()) {
						cout << "List is empty!\n";
					} else {
						cout << "List isn't empty.\n" ;
					}
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'c': {
				if (c[1]=='\0') {
					if (MyList.Circular()) {
						cout << "List is a circular list!\n";
					} else {
						cout << "List isn't a circular list.\n" ;
					}
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'a': {
				if (c[1]=='\0') {
					cout << "Input the element which will be added at the tail of the List:\n";
					cin >> dt;
					i=MyList.Add(dt);
					if (i<0) cout << "Error: the List is circular!\n";
					i=0;
				} else if (c[1]=='a') {
					cout << "Input the element which will be added after the Current Element of the List:\n";
					cin >> dt;
					i=MyList.AddAfter(dt);
					if (i<0) cout << "Error: the List is empty! The Current Element doesn't exist!\n";
					i=0;
				} else if (c[1]=='b') {
					cout << "Input the element which will be added before the Current Element of the List:\n";
					cin >> dt;
					i=MyList.AddBefore(dt);
					if (i<0) cout << "Error: the List is empty! The Current Element doesn't exist!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'p': {
				if (c[1]=='\0') {
					cout << "Input data which will be putted in the Current Element of the List:\n";
					cin >> dt;
					i=MyList.PutInCurrent(dt);
					if (i<0) cout << "Error: the List is empty! The Current Element doesn't exist!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'd': {
				if (c[1]=='\0') {
					i=MyList.DeleteCurrent();
					if (i<0) cout << "Error: the List is empty! The Current Element doesn't exist!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'g': {
				if (c[1]=='\0') {
					cout << "Input n:\n";
					cin >> n;
					i=MyList.Get(dt,n);
					cout << "The " << n << "-th element=" << dt <<"\n";
					if (i<0) cout << "Error: the List is circular! The Head doesn't exist! Or n > Length of the List\n";
					i=0;
				} else if (c[1]=='c') {
					i=MyList.GetCurrent(dt);
					cout << "The Current Element=" << dt << "\n";
					if (i<0) cout << "Error: the List is empty! The Current Element doesn't exist!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'h': {
				if (c[1]=='t') {
					i=MyList.HTProp();
					if (i==lNoHT) {
						cout << "The Current Element isn't a head or a tail.\n";
					} else if (i==lHead) {
						cout << "The Current Element is a head.\n";
					} else if (i==lTail) {
						cout << "The Current Element is a tail.\n";
					} else if (i==lHT) {
						cout << "The Current Element is a head and a tail.\n";
					} else cout << "Error: the List is empty!\n";
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'l': {
				if (c[1]=='\0') {
					n=MyList.Length();
					cout << "Length of the List=" << n <<".\n";
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 's': {
				if (c[1]=='h') {
					i=MyList.SetToHead();
					if (i<0) cout << "Error: the Head doesn't exist!\n";
					i=0;
				} else if (c[1]=='t') {
					i=MyList.SetToTail();
					if (i<0) cout << "Error: the Tail doesn't exist!\n";
					i=0;
				} else if (c[1]=='n') {
					i=MyList.SetToNext();
					if (i<0) cout << "Error: the Next element of the Current Element doesn't exist!\n";
					i=0;
				} else if (c[1]=='p') {
					i=MyList.SetToPrevious();
					if (i<0) cout << "Error: the Previous element of the Current Element doesn't exist!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 't': {
				if (c[1]=='a') {
					i=MyList.TearAfter();
					if (i<0) cout << "Error: the List isn't circular!\n";
					i=0;
				} else if (c[1]=='b') {
					i=MyList.TearBefore();
					if (i<0) cout << "Error: the List isn't circular!\n";
					i=0;
				} else cout << "Unknown command!!!\n";
				break;
			}
			case 'q': {
				if (c[1]=='\0') {
					cout << "Program was terminated!";
				} else cout << "Unknown command!!!\n";
				break;
			}
			default:
				cout << "Unknown command!!!\n";
		}
	} while((c[0]!='q')||(c[1]!='\0'));

	return 0;
}

template <class T> int PrintListState (List<T> L)
{
	int i=-1, k, n;
	T dt;
	cout << " + State of List: ";
	if (L.Empty()) {
		cout << "List is empty! Non-circular list! List doesn't have elements!\n";
	} else if (L.Circular()){	
		i=L.GetCurrent(dt);
		n=L.Length();
		cout << "List isn't empty. Circular list. The Current Element=" << dt << "\n" ;
		cout << "The Current Element isn't a head or a tail. List contains " << n << " element(s)\n" ;
		cout << "List contains follows element(s): ";
		k=0;
		while (k<n-1) {
			i=L.GetCurrent(dt);
			cout << dt << ", ";
			i=L.SetToNext();
			k++;
		}
		i=L.GetCurrent(dt);
		cout << dt << ".\n";
		i=L.SetToNext();
		k++;
	} else {
		i=L.GetCurrent(dt);
		cout << "List isn't empty. Non-circular list. The Current Element=" << dt << "\n" ;
		i=L.HTProp();
		if (i==lNoHT) {
			cout << "The Current Element isn't a head or a tail. ";
		} else if (i==lHead) {
			cout << "The Current Element is a head. ";
		} else if (i==lTail) {
			cout << "The Current Element is a tail. ";
		} else {
			cout << "The Current Element is a head and a tail. ";
		}
		n=L.Length();
		cout << "List contains " << n << " element(s)\n" ;
		cout << "List contains follows element(s): ";
		k=0;
		while (k<n-1) {
			k++;
			i=L.Get(dt,k);
			cout << dt << ", ";
		}
		k++;
		i=L.Get(dt,k);
		cout << dt << ".\n";
	}
	return 0;
}

/*
  -: Copyright  1999-2004 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
*/
